/*--[drm5locl.c]---------------------------------------------------------------
 | Copyright (C) 2002, 2003 Dan A. Jackson 
 |
 | This file is part of the "clit" (Convert LIT) program. 
 |
 | Convert LIT is free software; you can redistribute it and/or modify
 | it under the terms of the GNU General Public License as published by
 | the Free Software Foundation; either version 2 of the License, or
 | (at your option) any later version.
 |
 | This program is distributed in the hope that it will be useful,
 | but WITHOUT ANY WARRANTY; without even the implied warranty of
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 | GNU General Public License for more details.
 |
 | You should have received a copy of the GNU General Public License
 | along with this program; if not, write to the Free Software
 | Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 | 
 | The GNU General Public License may also be available at the following
 | URL: http://www.gnu.org/licenses/gpl.html
 */

#include "drm5hook.h"

PROCESS_INFORMATION pi;

extern DWORD stub_offset;
extern DWORD stub_size;

void create_random_name(char * sz, int n)
{
    DWORD   id, ticks, x;
    int     i;

    id = GetCurrentProcessId();
    ticks = GetTickCount();

    sz[0] = (char)(ticks % 26)+'A';
    x = id;
    for (i = 1; i < n; i++) { sz[i] = (char)(x%26)+'A'; x /= 26; if (!x) break;}
    x = ticks;
    for (; i < n; i++) { sz[i] = (char)(x%26)+'A'; x /= 26; if (!x) break; }
    x = ticks*id; 
    for (; i < n; i++) { sz[i] = (char)(x%26)+'A'; x /= 26; if (!x) break; }
    sz[n-1] = '\0'; 
}

#define FILENAME_SZ 9

int wpm(HANDLE h, LPVOID to, LPVOID from, DWORD n) {
    BOOL success;

    success = WriteProcessMemory(h,to,from,n, 0);
    if (!success) {
        common_error_handler(TRUE,
            "WriteProcessMemory failed for  %1!d! at %2!x! (%3!d! chars).",
            h, to, n);
    } 
    return success;   
} 

char    dll_path[MAX_PATH+1];
int drm5hook_install(char * szVictim, 
    p_external_error_handler user_error_routine)
{
    char    szDone[FILENAME_SZ+1], szExec[FILENAME_SZ+1], szMap[FILENAME_SZ+1];
    int     finished;
    BOOL    success;
    int     lenPath;
    STARTUPINFO si;
    CONTEXT ctxt;
    DWORD   offsetPath, offsetMap, offsetExec, offsetDone;
    DWORD   new_esp, retcode, parameters[9];

    if (user_error_routine)
        error_handler = user_error_routine;

    hDone = hExec = hMap = 0; 
    buffer = 0;

    create_random_name(szDone, FILENAME_SZ); szDone[0] = 'D';
    create_random_name(szExec, FILENAME_SZ); szExec[0] = 'E';
    create_random_name(szMap, FILENAME_SZ); szMap[0] = 'M'; 

    finished = 0; 
    do {  
        hDone = CreateEvent(NULL, FALSE, FALSE, szDone);
        if (!hDone) { 
            common_error_handler(TRUE, "Unable to CreateEvent %1!s!", szDone);
            break; 
        }
        hExec = CreateEvent(NULL, FALSE, FALSE, szExec);
        if (!hExec) { 
            common_error_handler(TRUE, "Unable to CreateEvent %1!s!", szExec);
            break; 
        }
        hMap = CreateFileMapping((HANDLE)-1,NULL,PAGE_READWRITE,0,BUFFER_SIZE,
            szMap);
        if (!hMap) {
            common_error_handler(TRUE,
                "Unable to CreateFileMapping for %1!s!, %2!d! chars.\n",
                    szMap, BUFFER_SIZE);
            break;
        }

        buffer = MapViewOfFile(hMap,FILE_MAP_WRITE,0,0,BUFFER_SIZE);
        if (!buffer) {
            common_error_handler(TRUE,
                "Unable to MapViewOfFile for %1!s!, %2!d! chars.\n",
                    szMap, BUFFER_SIZE);
        }
        
        lenPath = GetModuleFileName(hMyself, dll_path, MAX_PATH);
        if ((lenPath == sizeof(dll_path)) || (lenPath <=0)) {
            common_error_handler(TRUE,
                "Failed with GetModuleFilename for %1!x! = %2!d! (max is %3!d!.",
                hMyself, lenPath, MAX_PATH);
            break;
        }
        dll_path[lenPath++] = '\0';

        ZeroMemory(&si, sizeof(si)); 
        ZeroMemory(&pi, sizeof(pi)); 
        si.cb = sizeof(STARTUPINFO);
        si.dwFlags = STARTF_USESHOWWINDOW;
        si.wShowWindow = SW_SHOWNORMAL;
        success = CreateProcess(szVictim, "", 
            NULL, /* Process's SECURITY_ATTRIBUTES */
            NULL, /* Thread' SECURITY_ATTRIBUTES */
            TRUE, /* Child inherits handles */
            CREATE_SUSPENDED, 
            NULL, /* Environment */
            NULL, /* Starting directory */
            &si, &pi);
        if (!success) {
            common_error_handler(TRUE, "Failed to Create Process for %1!s!.",
                szVictim);
            break;
        }
         
        ctxt.ContextFlags = CONTEXT_FULL;
        success = GetThreadContext(pi.hThread, &ctxt);
        if (!success) {
            common_error_handler(TRUE,
                "GetThreadContext for thread %1!%d! failed.", pi.hThread);
            break;
        }

        /* Stack looks like:
         *
         *   Top Of Stack
         *   Data
         *      Path to DLL to be loaded
         *      IPC Paths
         *   Remote Stub
         *   Parameters To Remote Stub
         *   Stack Pointer
         */   
        offsetPath = ctxt.Esp - lenPath;  
        if (!wpm(pi.hProcess,(void*)offsetPath,dll_path,lenPath)) break;
        offsetMap = offsetPath - FILENAME_SZ;
        if (!wpm(pi.hProcess,(void*)offsetMap,szMap,FILENAME_SZ)) break;
        offsetExec = offsetMap - FILENAME_SZ;
        if (!wpm(pi.hProcess,(void*)offsetExec,szExec,FILENAME_SZ)) break;
        offsetDone = offsetExec - FILENAME_SZ;
        if (!wpm(pi.hProcess,(void*)offsetDone,szDone,FILENAME_SZ)) break;

        parameters[6] = (DWORD)&FreeLibraryAndExitThread;
        parameters[5] = offsetDone;
        parameters[4] = offsetExec;
        parameters[3] = offsetMap;
        parameters[2] = (DWORD)&GetProcAddress;
        parameters[1] = (DWORD)&LoadLibrary;
        parameters[0] = offsetPath;

        new_esp = offsetDone - stub_size;
        if (!wpm(pi.hProcess, (void*)new_esp, (void*)stub_offset, stub_size)) 
            break;

        ctxt.Eip = new_esp;  

        if (new_esp & 0xf) new_esp -= (new_esp & 0xf);
        new_esp = new_esp - sizeof(parameters);
        if (!wpm(pi.hProcess, (void*)new_esp, parameters, sizeof(parameters))) 
            break;

        ctxt.Esp = new_esp;
        
        ctxt.ContextFlags = CONTEXT_FULL;
        success = SetThreadContext(pi.hThread, &ctxt);
        if (!success)
        {
            common_error_handler(TRUE,
                "SetThreadContext for thread %1!d! failed.", pi.hThread);
            break;
        }
        retcode = ResumeThread(pi.hThread);
        if (retcode != 1) {
            common_error_handler(TRUE,
                "ResumeThread for %1!d! failed (%2!d!).",pi.hThread, retcode);
            break;
        }

        while (TRUE)
        {
            DWORD   exitcode;

            retcode = WaitForSingleObject(hDone, 5000);
            if (retcode == WAIT_TIMEOUT) {
               GetExitCodeProcess(pi.hProcess, &exitcode);
               if (exitcode != STILL_ACTIVE) {
                    common_error_handler(FALSE,
                        "DRM5HOOK was unable to install in remote thread.");
                    break;
               }
            }
            else if (!retcode) 
            {
                finished++;
                break;
            }
        }
    } while(0);
    if (!finished)
    {
        common_destroy_global_state();
        return -1;
    }
    return 0;
}

int send_remote_command(DWORD cmd, BYTE * pData, DWORD nData, BYTE * pResult,
    DWORD nResult)
{
    DWORD   response, nResponse;

    *(DWORD *)(buffer) = cmd;
    *(DWORD *)(buffer + 4) = nData;
    CopyMemory( buffer+16, pData, nData);
    SetEvent(hExec); 
    while (TRUE)
    {
        DWORD   retcode;
        DWORD   exitcode;

        retcode = WaitForSingleObject(hDone, 5000);
        if (retcode == WAIT_TIMEOUT) {
            GetExitCodeProcess(pi.hProcess, &exitcode);
            if (exitcode != STILL_ACTIVE) { 
                common_error_handler(FALSE,
                    "Remote thread terminated unexpectedly (CMD=%1!d!).", cmd);
                return -1;
            }
        } else if (!retcode) {
            response = *(DWORD *)(buffer);
            nResponse = *(DWORD *)(buffer + 4);
            if (response == RSP_ERROR) {
                if (error_handler) {
                    error_handler(0, buffer+16);
                } else {
                    MessageBoxA(NULL,buffer+16,"DRM5 HOOK DLL -- REMOTE ERROR",
                        MB_ICONERROR|MB_OK);
                }
                return -1;
            }
            if (response != RSP_OK) { 
                common_error_handler(FALSE,
                    "Remote thread returned %1!x! for CMD: %2!d!.",
                        response, cmd);
                return -1;
            }
            if (nResponse != nResult) {
                common_error_handler(FALSE, 
                    "Cmd length mismatch: CMD:%1!d!. %2!d! should be %3!d!.",
                        cmd, nResponse, nResult);
                return -1;
            }
            break;
        }
    }
    CopyMemory(pResult, buffer+16, nResult);
    return 0;
}

int drm5hook_init()
{
    return send_remote_command(CMD_INIT, NULL, 0, NULL, 0);
}

int drm5hook_decrypt(unsigned char * pData, int nData) {
    int offset, remaining, len;
    int err;

    remaining = nData;
    offset = 0;
    while (offset < nData) {
        len = BUFFER_SIZE;
        if (len > remaining) len = remaining;
        err = send_remote_command(CMD_DECRYPT, pData+offset, len, 
            pData + offset, len);
        if (err) return err; 
        remaining -= len;
        offset += len;
    } 
    return 0; 
}

int drm5hook_setkey(unsigned char * key, int keylen, DWORD extra) {
    DWORD   cmd;
    static  DWORD tmp_buffer[21];

    cmd = CMD_SETKEY;
    tmp_buffer[0] = extra;

    if (keylen > (sizeof(tmp_buffer) - 4)) {
        common_error_handler(0,
            "Encrypted key is too long. Fix drm5hook_setkey. %1!d! > %2!d!",
                keylen, sizeof(tmp_buffer) - 4);
        return -1;
    }
    CopyMemory(&tmp_buffer[1], key, keylen); 
    return send_remote_command(cmd, (unsigned char*)tmp_buffer, 
        keylen+4, NULL, 0);
}

